## Process this file with automake to produce Makefile.in

AUTOMAKE_OPTIONS = foreign

bin_PROGRAMS = dyalog
dyalog_HEADERS = dyalogrc
bin_SCRIPTS = dyacc

AM_CPPFLAGS = -I ${top_srcdir}/Runtime

dyalog_SOURCES = main.ma tools.ma reader.ma lpda.ma seed.ma application.ma \
	term.ma code.ma \
	code_emit.ma ma_emit.ma emit.ma format.ma \
	maker.ma config.ma dcg.ma bmg.ma rcg.ma \
        tag_maker.ma tag_normalize.ma tag_compile.ma tag_dyn.ma tagguide_compile.ma\
	oset.ma stdprolog.ma foreign.ma lc.ma toplevel.ma tig.ma tag_features.ma\
	compiler_sup.c

dyalog_LDADD = ${top_builddir}/Runtime/libdyalog.la
dyalog_LDFLAGS= ${PG} 

AM_CFLAGS=${PG}

PLSOURCES = main.pl tools.pl reader.pl lpda.pl seed.pl application.pl \
	term.pl code.pl \
	code_emit.pl ma_emit.pl emit.pl format.pl \
	maker.pl config.pl dcg.pl bmg.pl rcg.pl \
        tag_maker.pl tag_normalize.pl tag_compile.pl tag_dyn.pl tagguide_compile.pl\
	oset.pl stdprolog.pl foreign.pl lc.pl toplevel.pl tig.pl tag_features.pl

EXTRA_DIST = ${PLSOURCES} header.pl dyalogrc

MA_ASM= ${top_builddir}/Ma2Asm/dyam2asm
DYALOG= ${top_builddir}/Compiler/dyalog

DYALOG_FLAGS=

SUFFIXES= .pl .ma .s

.SECONDARY:  $(filter-out %.c,$(dyalog_SOURCES)) 

.ma.s :
	${MA_ASM} ${PG} $< -o $@

.pl.ma : header.pl
	${DYALOG} -a ${DYALOG_FLAGS} $< -o $@

.PHONY: bootstrap unbootstrap diff postsvn

SAVEDIR=save

bootstrap:
	-rm -rf $(SAVEDIR)
	mkdir $(SAVEDIR)
	-chmod 777 $(SAVEDIR)
	@mv $(filter-out %.c,$(dyalog_SOURCES)) $(SAVEDIR)/
	$(MAKE)  $(foreach file,$(PLSOURCES), -W ${file})

unbootstrap:
	@if test -d $(SAVEDIR); then \
	   here=`pwd` && cd $(SAVEDIR) && cp $(filter-out %.c,$(dyalog_SOURCES)) $$here/ ; \
	else \
	   echo "No saved files in $(SAVEDIR)" && exit 1; \
	fi
	$(MAKE)

diff:
	LC_ALL="C" diff -I '^;;' save/ ./ | grep -v '^Only' | less

postsvn:
	-touch *.ma
